<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { Breadcrumb } from '../../../interfaces';
import { SlpBreadcrumb } from '~/components/common/index.vue';

interface HeroImage {
  src: string;
  alt?: string;
}

interface HeroButton {
  text: string;
  externalUrl: string;
  variation?: string;
  iconName: string;
  iconVariant: string;
}

export default Vue.extend({
  components: {
    SlpBreadcrumb,
  },
  props: {
    header: {
      type: String,
      required: true,
    },
    subtitle: {
      type: String,
      required: false,
      default: '',
    },
    text: {
      type: String,
      required: true,
    },
    location: {
      type: String,
      required: true,
    },
    image: {
      type: Object as PropType<HeroImage>,
      required: true,
    },
    cta: {
      type: Object as PropType<HeroButton>,
      required: false,
      default: null,
    },
    breadcrumbs: {
      type: Array as PropType<Breadcrumb[]>,
      required: false,
      default: null,
    },
    registrationClosed: {
      type: Boolean,
      required: false,
      default: false,
    },
    expandHeader: {
      type: Boolean,
      required: false,
      default: false,
    },
    date: {
      type: String,
      required: false,
      default: '',
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <SlpContainer>
      <div class="hero-wrapper">
        <div class="hero-text" :class="{ 'hero-text--expand': expandHeader }">
          <SlpBreadcrumb
            v-if="breadcrumbs"
            class="slp-mb-32 breadcrumbs"
            :crumbs="breadcrumbs"
          />
          <SlpTypography variant="heading1-bold" tag="h1" class="slp-mb-24">{{
            header
          }}</SlpTypography>
          <SlpTypography variant="heading4" tag="h2" class="slp-mb-24">{{
            date
          }}</SlpTypography>
          <span class="location slp-mb-24"
            ><SlpIcon variant="product" name="location" size="sm" />
            <div
              variant="body1"
              class="address"
              v-html="$md.render(text)"
            ></div>
          </span>
          <SlpButton
            v-if="!registrationClosed"
            :href="cta.externalUrl"
            :variant="cta.variation"
            class="cta"
            >{{ cta.text }} {{ location }}
            <SlpIcon
              v-if="cta.iconName"
              :variant="cta.iconVariant"
              :name="cta.iconName"
              class="slp-ml-8"
          /></SlpButton>
        </div>
        <div v-if="image?.src" class="hero-image">
          <img :src="image.src" :alt="image.alt" />
        </div>
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  background: url('/nuxt-images/events/world-tour/city-hero-background.png');
  margin-bottom: 96px;
  background-repeat: no-repeat;
  background-size: 100% 100%;
}
.hero-wrapper {
  display: flex;
  flex-direction: column;
  align-items: center;
  gap: 32px;
  margin-top: $spacing-32;
  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    justify-content: space-around;
    align-items: center;
  }
  @media (min-width: $breakpoint-lg) {
    gap: 132px;
  }

  .hero-text {
    padding-bottom: 32px;
    min-width: 30%;
    &--expand {
      min-width: 45%;
    }
    .cta {
      white-space: nowrap;
    }
    .breadcrumbs:deep(span) {
      color: white;
      white-space: nowrap;
    }
    .location {
      display: flex;
      flex-direction: row;
      gap: 8px;
      @media (min-width: $breakpoint-lg) {
        white-space: nowrap;
      }

      .address:deep(p) {
        font-weight: 400;
        font-size: 20px;
        line-height: 24px;
      }
    }
    color: white;
    padding-top: 32px;
    @media (min-width: $breakpoint-md) {
      padding-top: 0;
    }
  }
  .hero-image {
    max-width: 65%;
    @media (min-width: $breakpoint-md) {
      align-self: flex-end;
    }
    img {
      margin-bottom: -7px;
      max-width: 450px;
      @media (max-width: $breakpoint-sm) {
        max-width: 300px;
      }

      @media (min-width: $breakpoint-lg) {
        max-width: unset;
        width: 100%;
      }
    }
    @media (min-width: $breakpoint-md) {
      margin: 0;
    }
  }
}
</style>
